// lab3.cpp : Magic square checker
//

#include "stdafx.h"
#include <iostream>
using namespace std;

const int SIZE = 4;  // magic suare size
int main(int argc, char* argv[])
{
/* the base array
{16,3,2,13},
{5,10,11,8},
{9,6,7,12},
{4,15,14,1},
*/
	int data[SIZE][SIZE] = {   // magic square candidate
				   {16,3,2,13},
				   {5,10,11,8},
				   {9,6,7,12},
				   {4,15,14,1},
			     };

	int colsums[SIZE];  // sums of all the columns
	int rowsums[SIZE];  // sums of all the rows
	int ldiag = 0,rdiag = 0;  // diagonal sums
	int r,c;

	// first print the potential square
	// print a row at a time
	for(r = 0; r<SIZE; r++) {   // rows
		for(c = 0; c < SIZE; c++)  // columns
			cout << data[r][c] << "\t";
		cout << endl;
	} // for


	// initialize the row and column sums
	for(r=0; r<SIZE; r++) rowsums[r] = colsums[r] = 0;

	// by using the arrays above, we can do all the summing in
	// one pass over the data.
	// I use the r index in the sums array because it is the most slowly
	// changing variable. I could have used a different counter
	// an incremented it after the c loop, but that would be the same thing
	// as r
	for(r=0; r<SIZE; r++)   // each row
	{
		for(c=0; c<SIZE; c++)   // each column
		{
			colsums[r] += data[c][r];	
			rowsums[r] += data[r][c];	
			if(r == c) rdiag += data[r][c]; // upper left to lower right
			if((r+c) == (SIZE - 1)) ldiag += data[r][c]; // upper right to lower left
		} // for c
	} // for r

	// check that all row totals are the same
	for(r=0; r<SIZE; r++) {
		if(rowsums[r] != rowsums[0])
		{
			cout << "The square is not Magic" << endl;
			cout << "row " << r << " is different" << endl;
		    return 1;
		}
	}

	// check that all column totals are the same
	for(c=0; c<SIZE; c++) {
		if(colsums[c] != colsums[0])
		{
			cout << "The square is not Magic" << endl;
			cout << "column " << c << " is different" << endl;
		    return 1;
		}
	}

	// check that column totals equal the row totals
	if(rowsums[0] != colsums[0])
	{
		cout << "The square is not Magic" << endl;
		cout << "The column sum doesn't match the row sum" << endl;
		return 1;
	}

	// compare the diagonal totals
	if(ldiag != rdiag)
	{
		cout << "The square is not Magic" << endl;
		cout << "The left diagonal sum doesn't match the right diagonal sum" << endl;
		return 1;
	}

	// at this point, we know the row sums = the column sums
	// and that the diagonal sums are equal. Last check is that 
	// the diagonals = the rows and columns
	if(rowsums[0] != rdiag)
	{
		cout << "The square is not Magic" << endl;
		cout << "The diagonal sum doesn't match the row sum" << endl;
		return 1;
	}

	 // all values are the same, so pick one
	cout << "The square is Magic and the sum is " << ldiag << endl;
	return 0;
}
